#include <string.h>
#include <stdio.h>
#include <ilwd/ldascontainer.hh>
#include <ilwd/ldasarray.hh>
#include <ilwd/ldasstring.hh>
#include<ilwd/util.hh>
using ILwd::LdasContainer;
using ILwd::LdasArray;
using ILwd::LdasString;
using namespace std;
typedef double BLOB_TYPE;
extern void get_gpstime( double *, double *);
LdasContainer ilwd3frameset_chanlist( "frameset_chanlistgroup:frameset_chanlist:table" );

namespace local {

	const INT_2U ARRAYSIZE = 10000;
	int thistime = (int)time (0) ;
	int numElements;
	double gps_secs ;
	double gps_nanosecs ;
	INT_2U BLOBSIZE = 64;
	LdasContainer process_id_cont ( "frameset_chanlistgroup:frameset_chanlist:process_id" ); 
	LdasContainer frameset_group_cont ( "frameset_chanlistgroup:frameset_chanlist:frameset_group" ); 
	INT_4S	start_time[ARRAYSIZE];
	INT_4S	end_time[ARRAYSIZE];
	INT_4S	chanlist_length[ARRAYSIZE];
} // end namespace

#ifdef TESTMAIN
#include	"process.h"
#endif

#ifdef  TESTSYMREF
#include	"process_symref.h"
#endif

using namespace local;

static void setup_process_id () {

// fill in process_id array
// NOT NULL
	char process_id_str[30] ;
	CHAR_U process_id[13];
	CHAR process_idattr[200];

	int i,j;
// convert process_id string to 13 bit BCD
	for (int i=0; i < numElements; i++) {
		strcpy(process_id_str, process[ i % process_len	].PROCESS_ID);
		for ( int x = 0, j = 0; x < strlen(process_id_str); x=x+2, j++ ) {
			process_id[j] = ((process_id_str[x]-'0' ) << 4) + (process_id_str[x+1]-'0');
		}
		sprintf(process_idattr, "process_id:%s", process_id_str);
		LdasArray< CHAR_U > process_id_vector ( process_id, 13,
		"frameset_chanlistgroup:frameset_chanlist:process_id" );
		process_id_vector.setComment(process_idattr);
		process_id_cont.push_back( process_id_vector );
	}
}

static void setup_process_id_symref () {
// fill in process_id array
// NOT NULL
	CHAR process_id[30] ;
	CHAR process_idattr[200];
	for (int i=0; i < numElements; i++) {
		strcpy(process_id, process[ i % process_len ].PROCESS_ID );
		sprintf( process_idattr, "process_id:%s", process_id );
		LdasArray< CHAR > process_id_vector ( process_id, strlen(process_id),
		"frameset_chanlistgroup:frameset_chanlist:process_id");
		process_id_vector.setComment(process_idattr);
		process_id_cont.push_back( process_id_vector );}
}

static void setup_frameset_group () {

// fill in frameset_group array
// NOT NULL
	CHAR frameset_group[48];
	CHAR frameset_groupattr[248];

	for (int i=0; i < numElements; i++) {
		snprintf(frameset_group, (size_t) 48, "frameset_group_%d", i + thistime + 1 );
		sprintf(frameset_groupattr, "frameset_chanlist:%s", frameset_group);
		LdasArray< CHAR > frameset_group_vector ( frameset_group, strlen(frameset_group),
			"frameset_chanlistgroup:frameset_chanlist:frameset_group" );
		frameset_group_vector.setComment( frameset_groupattr );
		frameset_group_cont.push_back( frameset_group_vector );
	}
}

static void setup_start_time () {

// fill in start_time array
	get_gpstime( &gps_secs, &gps_nanosecs );
	for (int i=0; i < numElements; i++) {
		start_time[i] = (INT_4S) ( i + gps_secs );}
}

static void setup_end_time () {

// fill in end_time array
	get_gpstime( &gps_secs, &gps_nanosecs );
	for (int i=0; i < numElements; i++) {
		end_time[i] = (INT_4S) ( i + gps_secs );
}
}

static void setup_chanlist_id () {

// fill in chanlist_id array
// NOT NULL
// chanlist_id is uniqueId, generated by metadataAPI

}

static void setup_chanlist_length () {

// fill in chanlist_length array
// NOT NULL
	for (int i=0; i < numElements; i++) {
		chanlist_length[i] = (INT_4S) i + thistime + 1 ;
	}
}

void setup_frameset_chanlist ( int dims ) 
{
	numElements = dims ;
	if	( dims == 1000 ) {
		BLOBSIZE = 5 ;
	}
	setup_process_id();
	ilwd3frameset_chanlist.push_back( process_id_cont ) ;
	setup_frameset_group();
	ilwd3frameset_chanlist.push_back(  frameset_group_cont ) ;
	setup_start_time();
	ilwd3frameset_chanlist.push_back(  LdasArray< INT_4S >(start_time, numElements,
	"frameset_chanlistgroup:frameset_chanlist:start_time" ) );
	setup_end_time();
	ilwd3frameset_chanlist.push_back(  LdasArray< INT_4S >(end_time, numElements,
	"frameset_chanlistgroup:frameset_chanlist:end_time" ) );
	setup_chanlist_id();
	setup_chanlist_length();
	ilwd3frameset_chanlist.push_back(  LdasArray< INT_4S >(chanlist_length, numElements,
	"frameset_chanlistgroup:frameset_chanlist:chanlist_length" ) );
}

#ifdef TESTMAIN 
 void setup_frameset_chanlist( int dims ); 

 int main(int argc, char **argv) {
 	LdasContainer ilwd1( "ligo:ldas:file" );
 	setup_frameset_chanlist( atoi ( argv [1] ) );
 	ilwd1.push_back( ilwd3frameset_chanlist );
 	ILwd::writeHeader(cout);
 	ilwd1.write( 0, 4, cout, ILwd::ASCII, ILwd::NO_COMPRESSION );
 	//ilwd1.write( 0, 4, cout, ILwd::BINARY, ILwd::NO_COMPRESSION );
 	cout << endl;
}
#endif
